package statej.ast;

import statej.Visitor;

import statej.typeChecker.ClassSymbol;

/**
 * <p>Title: Programming mini project 2 Java-- compiler</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004 NIcholas Cameron</p>
 * <p>Company: </p>
 * @author Nicholas Cameron
 * @version 1.0
 */

public class ClassNode extends Node
{
    private String name, superClass;
    private ListNode slots = null;

    private ClassSymbol symbol;

    public ClassNode(String name, String superClassName, ListNode slots, int lineNumber, int colNumber)
    {
        super(lineNumber, colNumber);
        this.name = name;
        this.superClass = superClassName;
        this.slots = slots;
    }

    public ClassNode(String name, ListNode slots, int lineNumber, int colNumber)
    {
        this(name, "Object",  slots, lineNumber, colNumber);
    }

    public Object accept(Visitor v)
    {
        return v.visit(this);
    }
    public String getName()
    {
        return name;
    }
    public String getSuperClass()
    {
        return superClass;
    }

    public Object[] visitSlots(Visitor v)
    {
        if (slots != null)
        {
            Node[] slotsArray = slots.toArray();
            Object[] result = new Object[slotsArray.length];
            for (int i = 0; i < slotsArray.length; ++i)
            {
            	result[i] = slotsArray[i].accept(v);
            }
            
            return result;
        }
        else
        	return new Object[0];
    }

    public String toString()
    {
        String result = "class " + name;
        if (!(superClass == null || superClass.equals("Object")))
            result += " extends " + superClass;

        return result;
    }

    public void setSymbol(ClassSymbol symbol)
    {
        this.symbol = symbol;
    }
    public ClassSymbol getSymbol()
    {
        return symbol;
    }
    public String eol()
    {
    	throw new RuntimeException("non-promotable expression");
    }
}