package statej.ast;

import statej.Visitor;

import statej.typeChecker.ClassSymbol;
import statej.typeChecker.FieldSymbol;

/**
 * <p>Title: Programming mini project 2 Java-- compiler</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004 NIcholas Cameron</p>
 * <p>Company: </p>
 * @author Nicholas Cameron
 * @version 1.0
 */

public class FieldAccessNode extends ExprNode
{
    private ExprNode target;
    private String fieldName;

    private FieldSymbol symbol = null;
    private ClassSymbol targetSymbol = null;

    public FieldAccessNode(ExprNode target, String fieldName, int lineNumber, int colNumber)
    {
        super(lineNumber, colNumber);
        this.target = target;
        this.fieldName = fieldName;
    }

    public Object accept(Visitor v)
    {
        return v.visit(this);
    }

    public String toString()
    {
        return target + "." + fieldName;
    }

    public Object visitTarget(Visitor v)
    {
        return target.accept(v);
    }

    public String getName()
    {
        return fieldName;
    }
    public FieldSymbol getSymbol()
    {
        return symbol;
    }
    public void setSymbol(FieldSymbol symbol)
    {
        this.symbol = symbol;
    }
    public ClassSymbol getTargetSymbol()
    {
        return targetSymbol;
    }
    public void setTargetSymbol(ClassSymbol targetSymbol)
    {
        this.targetSymbol = targetSymbol;
    }
    public String eol()
    {
    	throw new RuntimeException("non-promotable expression");
    }
}