package statej.ast;

import statej.Visitor;

public class SpawnNode extends ExprNode
{
	protected Node stmt;
	
	public SpawnNode(Node stmt, int rowNumber, int colNumber)
	{
		super(rowNumber, colNumber);
		this.stmt = stmt;
	}
	public Object accept(Visitor v)
	{
		return v.visit(this);
	}

	public String toString()
	{
		return "spawn(" + stmt + ")";
	}
	
	public Object visitStmt(Visitor v)
	{
		return stmt.accept(v);
	}
}
