package statej.ast;

import statej.Visitor;
import statej.typeChecker.StateSymbol;

public class StateChangeNode extends ExprNode
{
	protected String stateName;
	
	protected StateSymbol stateSymbol;
	
	public StateChangeNode(String stateName, int rowNumber, int colNumber)
	{
		super(rowNumber, colNumber);
		this.stateName = stateName;
	}
	
	public Object accept(Visitor v)
	{
		return v.visit(this);
	}

	public String getName()
	{
		return stateName;
	}
	
	public String toString()
	{
		return "this!!" + stateName;
	}

	public StateSymbol getStateSymbol()
	{
		return stateSymbol;
	}

	public void setStateSymbol(StateSymbol stateSymbol)
	{
		this.stateSymbol = stateSymbol;
	}

	public String eol()
	{
		return "\n";
	}
}
