package statej.ast;

import statej.Visitor;
import statej.typeChecker.Modifier;
import statej.typeChecker.StateSymbol;

public class StateDefNode extends SlotNode
{
	protected ListNode methods;
	protected StateSymbol symbol;
	
	public StateDefNode(String name, ListNode methods, int rowNumber, int colNumber)
	{
		super(name, Modifier.PROTECTED, "void", rowNumber, colNumber);
		this.methods = methods;
	}
	public Object accept(Visitor v)
	{
		return v.visit(this);
	}
	
	public String toString()
	{
		return "state " + name + "\n{\n" + methods + "}\n";
	}
	
    public String eol()
    {
    	throw new RuntimeException("non-promotable expression");
    }
    
    public Object[] visitMethods(Visitor v)
    {
    	Node[] nodes = methods.toArray();
    	Object[] result = new Object[nodes.length];
    	for (int i = 0; i < result.length; ++i)
    	{
    		result[i] = nodes[i].accept(v);
    	}
    	return result;
    }
    public void setSymbol(StateSymbol symbol)
    {
        this.symbol = symbol;
    }

    public StateSymbol getSymbol()
    {
        return symbol;
    }
}
